diff --git a/configure.ac b/configure.ac
index 5011221..e7ee60b 100644
--- a/configure.ac
+++ b/configure.ac
@@ -2743,15 +2693,13 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([dxva2])], [
       AC_MSG_ERROR([--enable-dxva2 needs a working avcodec.])
     ])
   ])
-  fi
 ])
 
 
 dnl
 dnl stream_out switcher needs libavcodec
 dnl
-AC_ARG_ENABLE(switcher,
-  [  --enable-switcher       Stream-out switcher plugin (default disabled)])
+VLC_FEATURE_OPTION([switcher], [Stream-out switcher plugin], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([switcher])], [
   AS_IF([test "x${have_avcodec}" = "xyes"], [
     VLC_ADD_PLUGIN([stream_out_switcher])
@@ -2765,10 +2713,8 @@ AS_IF([VLC_FEATURE_ENABLED([switcher])], [
 dnl
 dnl  avformat demuxer/muxer plugin
 dnl
-
-AC_ARG_ENABLE(avformat,
-[  --enable-avformat       libavformat containers (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([avformat])], [
+VLC_FEATURE_OPTION([avformat], [libavformat containers])
+AS_IF([VLC_FEATURE_ENABLED([avformat])], [
   PKG_CHECK_MODULES(AVFORMAT,[libavformat libavutil],
     [
       VLC_SAVE_FLAGS
@@ -2776,7 +2722,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([avformat])], [
       CFLAGS="${CFLAGS} ${AVFORMAT_CFLAGS}"
       AC_CHECK_HEADERS(libavformat/avformat.h ffmpeg/avformat.h)
       AC_CHECK_HEADERS(libavutil/avutil.h ffmpeg/avutil.h)
-      AS_IF([VLC_FEATURE_NOT_ENABLED([merge-ffmpeg])], [
+      AS_IF([VLC_FEATURE_DISABLED([merge-ffmpeg])], [
         VLC_ADD_PLUGIN([avformat access_avio])
         VLC_ADD_LIBS([avformat access_avio],[$AVFORMAT_LIBS $AVUTIL_LIBS])
         VLC_ADD_CFLAGS([avformat access_avio],[$AVFORMAT_CFLAGS $AVUTIL_CFLAGS])
@@ -2793,11 +2739,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([avformat])], [
 dnl
 dnl  swscale image scaling and conversion plugin
 dnl
-
-AC_ARG_ENABLE(swscale,
-  AS_HELP_STRING([--enable-swscale],[libswscale image scaling and conversion
-		  (default enabled)]))
-AS_IF([VLC_FEATURE_NOT_DISABLED([swscale])], [
+VLC_FEATURE_OPTION([swscale], [libswscale image scaling and conversion])
+AS_IF([VLC_FEATURE_ENABLED([swscale])], [
   PKG_CHECK_MODULES(SWSCALE,[libswscale],
     [
       VLC_SAVE_FLAGS
@@ -2816,10 +2759,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([swscale])], [
 dnl
 dnl  postproc plugin
 dnl
-
-AC_ARG_ENABLE(postproc,
-[  --enable-postproc       libpostproc image post-processing (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([postproc])], [
+VLC_FEATURE_OPTION([postproc], [libpostproc image post-processing])
+AS_IF([VLC_FEATURE_ENABLED([postproc])], [
   PKG_CHECK_MODULES(POSTPROC,[libpostproc libavutil],
     [
       VLC_SAVE_FLAGS
@@ -2838,8 +2779,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([postproc])], [
 dnl
 dnl  faad decoder plugin
 dnl
-AC_ARG_ENABLE(faad,
-[  --enable-faad           faad codec (default disabled)])
+VLC_FEATURE_OPTION([faad], [faad codec], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([faad])], [
   AC_ARG_WITH(faad-tree,
   [  --with-faad-tree=PATH   faad tree for static linking])
@@ -2890,8 +2830,7 @@ PKG_ENABLE_MODULES_VLC([TWOLAME], [], [twolame], [MPEG Audio Layer 2 encoder], [
 dnl
 dnl  QuickTime plugin
 dnl
-AC_ARG_ENABLE(quicktime,
-  [  --enable-quicktime      QuickTime module (deprecated)])
+VLC_FEATURE_OPTION([quicktime], [QuickTime module (deprecated)], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([quicktime])], [
   if test "${SYS}" = "mingw32"; then
     VLC_ADD_PLUGIN([quicktime])
@@ -2906,8 +2845,7 @@ AS_IF([VLC_FEATURE_ENABLED([quicktime])], [
 dnl
 dnl  Real plugin
 dnl
-AC_ARG_ENABLE(real,
-  [  --enable-real           Real media module (default disabled)])
+VLC_FEATURE_OPTION([real], [Real media module], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([real])], [
   VLC_ADD_PLUGIN([realvideo])
 ])
@@ -2915,16 +2853,13 @@ AS_IF([VLC_FEATURE_ENABLED([real])], [
 dnl
 dnl  Real RTSP plugin
 dnl
-AC_ARG_ENABLE(realrtsp,
-  [  --enable-realrtsp       Real RTSP module (default disabled)])
+VLC_FEATURE_OPTION([realrtsp], [Real RTSP module], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([realrtsp])], [
   VLC_ADD_PLUGIN([access_realrtsp])
 ])
 
-AC_ARG_ENABLE(libsysfs,
-  [  --enable-libsysfs       Get user key from firewire connected iPod via libsysfs (default enabled)])
-
-AS_IF([VLC_FEATURE_NOT_DISABLED([libsysfs])], [
+VLC_FEATURE_OPTION([libsysfs], [Get user key from firewire connected iPod via libsysfs])
+AS_IF([VLC_FEATURE_ENABLED([libsysfs])], [
   AC_CHECK_HEADERS(sysfs/libsysfs.h, [
     VLC_ADD_LIBS([mp4 mkv],[-lsysfs])
   ] )
@@ -2933,10 +2868,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([libsysfs])], [
 dnl
 dnl skins2 module
 dnl
-AC_ARG_ENABLE(libtar,
-  [  --enable-libtar         libtar support for skins2 (default enabled)])
-
-AS_IF([VLC_FEATURE_NOT_DISABLED([libtar])], [
+VLC_FEATURE_OPTION([libtar], [libtar support for skins2])
+AS_IF([VLC_FEATURE_ENABLED([libtar])], [
   AC_CHECK_HEADERS(libtar.h, [
     VLC_ADD_LIBS([skins2],[-ltar])
   ] )
@@ -2945,9 +2878,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([libtar])], [
 dnl
 dnl A52/AC3 decoder plugin
 dnl
-AC_ARG_ENABLE(a52,
-  [  --enable-a52            A/52 support with liba52 (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([a52])], [
+VLC_FEATURE_OPTION([a52], [A/52 support with liba52])
+AS_IF([VLC_FEATURE_ENABLED([a52])], [
   AC_ARG_WITH(a52,
     [  --with-a52=PATH         a52 headers and libraries])
   AC_ARG_WITH(a52-tree,
@@ -3041,8 +2973,7 @@ PKG_ENABLE_MODULES_VLC([VORBIS], [], [ogg vorbis >= 1.1 vorbisenc >= 1.1], [Vorb
 dnl
 dnl  Tremor plugin
 dnl
-AC_ARG_ENABLE(tremor,
-  [  --enable-tremor         Tremor decoder support (default disabled)])
+VLC_FEATURE_OPTION([tremor], [Tremor decoder support], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([tremor])], [
   AC_CHECK_HEADERS(tremor/ivorbiscodec.h, [
     VLC_ADD_PLUGIN([tremor])
@@ -3073,9 +3004,8 @@ PKG_ENABLE_MODULES_VLC([SCHROEDINGER], [], [schroedinger-1.0 >= 1.0.6], [dirac d
 dnl
 dnl  PNG decoder module
 dnl
-AC_ARG_ENABLE(png,
-  [  --enable-png            PNG support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([png])], [
+VLC_FEATURE_OPTION([png], [PNG support])
+AS_IF([VLC_FEATURE_ENABLED([png])], [
 AC_CHECK_HEADERS(png.h, [
   LDFLAGS="${LDFLAGS_save} -lz"
   AC_CHECK_LIB(png, png_set_rows, [
@@ -3085,14 +3015,13 @@ AC_CHECK_HEADERS(png.h, [
     LDFLAGS="${LDFLAGS_save}"
   ])
 ])
-AM_CONDITIONAL(BUILD_OSDMENU, [VLC_FEATURE_NOT_DISABLED([png])])
+AM_CONDITIONAL(BUILD_OSDMENU, [VLC_FEATURE_ENABLED([png])])
 
 dnl
 dnl H264 encoder plugin (using libx264)
 dnl
-AC_ARG_ENABLE(x264,
-  [  --enable-x264           H264 encoding support with libx264 (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([x264])], [
+VLC_FEATURE_OPTION([x264], [H264 encoding support with libx264])
+AS_IF([VLC_FEATURE_ENABLED([x264])], [
   AC_ARG_WITH(x264-tree,
     [  --with-x264-tree=PATH   x264 tree for static linking ],[],[])
   if test "${with_x264_tree}" != "no" -a -n "${with_x264_tree}"
@@ -3165,14 +3094,9 @@ dnl vbi decoder plugin (using libzbvi)
 dnl telx module
 dnl uncompatible
 dnl
-AC_ARG_ENABLE(zvbi,
-  AS_HELP_STRING([--enable-zvbi],[VBI (inc. Teletext) decoding support with
-                  libzvbi (default enabled)]))
-AC_ARG_ENABLE(telx,
-  AS_HELP_STRING([--enable-telx],[Teletext decoding module (conflicting with
-                  zvbi) (default enabled if zvbi is absent)]))
-
-AS_IF([VLC_FEATURE_NOT_DISABLED([zvbi])], [
+VLC_FEATURE_OPTION([zvbi], [VBI (inc. Teletext) decoding support with libzvbi])
+VLC_FEATURE_OPTION([telx], [Teletext decoding module (conflicting with zvbi)])
+AS_IF([VLC_FEATURE_ENABLED([zvbi])], [
     PKG_CHECK_MODULES(ZVBI,
         zvbi-0.2 >= 0.2.28,
         [
@@ -3191,16 +3115,15 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([zvbi])], [
           AC_MSG_WARN(ZVBI library not found. Enabling the telx module instead)
         ])
     ])
-AS_IF([VLC_FEATURE_NOT_DISABLED([telx])], [
+AS_IF([VLC_FEATURE_ENABLED([telx])], [
   VLC_ADD_PLUGIN([telx])
   ])
 
 dnl
 dnl libass subtitle rendering module
 dnl
-AC_ARG_ENABLE(libass,
-  [  --enable-libass         Subtitle support using libass (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([libass])], [
+VLC_FEATURE_OPTION([libass], [Subtitle support using libass])
+AS_IF([VLC_FEATURE_ENABLED([libass])], [
   PKG_CHECK_MODULES(LIBASS, libass >= 0.9.6,
       [
         VLC_ADD_LIBS([libass],[$LIBASS_LIBS])
@@ -3219,8 +3142,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([libass])], [
 dnl
 dnl asa demuxer
 dnl
-AC_ARG_ENABLE(asademux,
-  [  --enable-asademux       asa subtitle demuxing (default disabled)])
+VLC_FEATURE_OPTION([asademux], [asa subtitle demuxing], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([asademux])], [
   PKG_CHECK_MODULES(PCRE,
       libpcre >= 6.5,
@@ -3239,9 +3161,8 @@ AS_IF([VLC_FEATURE_ENABLED([asademux])], [
 dnl
 dnl  kate decoder plugin
 dnl
-AC_ARG_ENABLE(kate,
-[  --enable-kate           kate codec (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([kate])], [
+VLC_FEATURE_OPTION([kate], [kate codec])
+AS_IF([VLC_FEATURE_ENABLED([kate])], [
   PKG_CHECK_MODULES(KATE,[kate >= 0.1.5], [
       VLC_ADD_PLUGIN([kate])
       VLC_ADD_CFLAGS([kate],[$KATE_CFLAGS])
@@ -3269,9 +3190,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([kate])], [
 dnl
 dnl  tiger rendering for kate decoder plugin
 dnl
-AC_ARG_ENABLE(tiger,
-[  --enable-tiger          Tiger rendering library for Kate streams (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([tiger])], [
+VLC_FEATURE_OPTION([tiger], [Tiger rendering library for Kate streams])
+AS_IF([VLC_FEATURE_ENABLED([tiger])], [
   PKG_CHECK_MODULES(TIGER,[tiger >= 0.3.1], [
       AC_DEFINE(HAVE_TIGER, 1, [Define if libtiger is available.])
       VLC_ADD_CFLAGS([kate],[$TIGER_CFLAGS])
@@ -3301,29 +3221,32 @@ dnl  X C Bindings modules
 dnl
 AS_CASE(
   ["${SYS}"],
-  [mingw32|mingwce|darwin], [VLC_FEATURE_DEFAULT_DISABLE([xcb])],
-  [VLC_FEATURE_DEFAULT_ENABLE([xcb])
-])
+  [mingw32|mingwce|darwin], [
+    VLC_FEATURE_DEFAULT_DISABLE([xcb])
+  ],
+  [
+    VLC_FEATURE_DEFAULT_ENABLE([xcb])
+  ]
+)
 
 AS_IF([VLC_FEATURE_REMOVED([xcb])], [
-  VLC_FEATURE_DEFAULT_DISABLE([xvideo])
-  VLC_FEATURE_DEFAULT_DISABLE([glx])
+  VLC_FEATURE_DEFAULT_DISABLE([xvideo glx])
+], [
+  VLC_FEATURE_DEFAULT_ENABLE([xvideo glx])
 ])
 
-AC_ARG_ENABLE(xcb,
-  [  --enable-xcb            X11 support with XCB (default enabled)])
-AC_ARG_ENABLE(xvideo,
-  [  --enable-xvideo         XVideo support (default enabled)])
+VLC_FEATURE_OPTION([xcb], [X11 support with XCB], [auto])
+VLC_FEATURE_OPTION([xvideo], [XVideo support], [enabled if using xcb])
 
 need_xid_provider="no"
-AS_IF([VLC_FEATURE_NOT_DISABLED([xcb])], [
+AS_IF([VLC_FEATURE_ENABLED([xcb])], [
   dnl libxcb
   PKG_CHECK_MODULES(XCB, [xcb])
   PKG_CHECK_MODULES(XCB_SHM, [xcb-shm])
   VLC_ADD_PLUGIN([screensaver xcb_x11 xcb_screen xcb_apps])
   VLC_SET_CFLAGS_WERROR([xcb_screen], [-Wno-error=uninitialized]) # some gcc report a warning which doesn't reveal an error
 
-  AS_IF([VLC_FEATURE_NOT_DISABLED([xvideo])], [
+  AS_IF([VLC_FEATURE_ENABLED([xvideo])], [
     PKG_CHECK_MODULES(XCB_XV, [xcb-xv >= 1.1.90.1], [
       VLC_ADD_PLUGIN([xcb_xv])
     ], [
@@ -3362,9 +3285,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([xcb])], [
   VLC_ADD_PLUGIN([xdg_screensaver])
 ])
 
-AC_ARG_ENABLE(glx,
-  [  --enable-glx            X11 OpenGL (GLX) support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([glx])], [
+VLC_FEATURE_OPTION([glx], [X11 OpenGL (GLX) support], [enabled if using xcb])
+AS_IF([VLC_FEATURE_ENABLED([glx])], [
   PKG_CHECK_MODULES(XLIB_XCB, [x11-xcb])
   PKG_CHECK_MODULES(GL, [gl],, [
     AC_CHECK_HEADER([GL/gl.h], [
@@ -3384,9 +3306,8 @@ dnl
 dnl  OpenGL module
 dnl  (enabled by default except on beos)
 dnl
-AC_ARG_ENABLE(opengl,
-  [  --enable-opengl         OpenGL support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([opengl]) && test "${SYS}" = "darwin"], [
+VLC_FEATURE_OPTION([opengl], [OpenGL support])
+AS_IF([VLC_FEATURE_ENABLED([opengl]) && test "${SYS}" = "darwin"], [
     dnl OS X special case (no GL/gl.h but OpenGL/gl.h)
     VLC_ADD_PLUGIN([opengl])
     VLC_ADD_LIBS([opengl],[-Wl,-framework,OpenGL])
@@ -3395,11 +3316,9 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([opengl]) && test "${SYS}" = "darwin"], [
 dnl
 dnl  SDL module
 dnl
-AC_ARG_ENABLE(sdl,
-  [  --enable-sdl            SDL support (default enabled)])
-AC_ARG_ENABLE(sdl-image,
-  [  --enable-sdl-image      SDL image support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([sdl])], [
+VLC_FEATURE_OPTION([sdl], [SDL support])
+VLC_FEATURE_OPTION([sdl-image], [SDL image support])
+AS_IF([VLC_FEATURE_ENABLED([sdl])], [
   SDL_PATH="${PATH}"
   AC_ARG_WITH(sdl-config-path,
     [  --with-sdl-config-path=PATH sdl-config path (default search in \$PATH)],
@@ -3421,7 +3340,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([sdl])], [
         VLC_ADD_LIBS([vout_sdl aout_sdl sdl_image],[`${SDL_CONFIG} --libs | sed 's,-rdynamic,,'`])
 
         # SDL_image
-        AS_IF([VLC_FEATURE_NOT_DISABLED([sdl-image])], [
+        AS_IF([VLC_FEATURE_ENABLED([sdl-image])], [
           AC_CHECK_HEADERS("SDL/SDL_image.h", [
             VLC_ADD_PLUGIN([sdl_image])
             AC_CHECK_LIB(png, png_set_rows, [VLC_ADD_LIBS([sdl_image],[-lpng -lz])],[],[-lz])
@@ -3448,13 +3367,10 @@ from http://www.libsdl.org/, or configure with --disable-sdl. Have a nice day.
 dnl
 dnl  freetype module
 dnl
-AC_ARG_ENABLE(freetype,
-  [  --enable-freetype       freetype support (default enabled)])
-AC_ARG_ENABLE(fribidi,
-  [  --enable-fribidi        fribidi support (default enabled)])
-AC_ARG_ENABLE(fontconfig,
-  [  --enable-fontconfig     fontconfig support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([freetype])], [
+VLC_FEATURE_OPTION([freetype], [freetype support])
+VLC_FEATURE_OPTION([fribidi], [fribidi support])
+VLC_FEATURE_OPTION([fontconfig], [fontconfig support])
+AS_IF([VLC_FEATURE_ENABLED([freetype])], [
    PKG_CHECK_MODULES(FREETYPE, freetype2,[
       VLC_ADD_PLUGIN([freetype])
       have_freetype=yes
@@ -3463,7 +3379,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([freetype])], [
         VLC_ADD_LIBS([freetype],[-liconv -lz])
       fi
       VLC_ADD_LIBS([freetype skins2],[${FREETYPE_LIBS}])
-      AS_IF([VLC_FEATURE_NOT_DISABLED([fontconfig])], [
+      AS_IF([VLC_FEATURE_ENABLED([fontconfig])], [
         AC_CHECK_HEADERS(fontconfig/fontconfig.h,
           [VLC_ADD_CPPFLAGS([freetype],[-DHAVE_FONTCONFIG])
            VLC_ADD_LIBS([freetype],[-lfontconfig])])
@@ -3472,7 +3388,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([freetype])], [
       ])
 
      dnl fribidi support
-      AS_IF([VLC_FEATURE_NOT_DISABLED([fribidi])], [
+      AS_IF([VLC_FEATURE_ENABLED([fribidi])], [
         PKG_CHECK_MODULES(FRIBIDI, fribidi, [
           VLC_ADD_CPPFLAGS([freetype skins2], [${FRIBIDI_CFLAGS} -DHAVE_FRIBIDI])
           VLC_ADD_LIBS([freetype skins2], [${FRIBIDI_LIBS}])
@@ -3503,18 +3419,22 @@ PKG_ENABLE_MODULES_VLC([SVG], [], [librsvg-2.0 >= 2.9.0], [SVG rendering library
 dnl
 dnl Snapshot vout module (with cache)
 dnl
-AC_ARG_ENABLE(snapshot,
-  [  --enable-snapshot       snapshot module (default disabled)])
+VLC_FEATURE_OPTION([snapshot], [snapshot module], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([snapshot])], [
   VLC_ADD_PLUGIN([snapshot])
 ])
 
 dnl
-dnl Roku HD1000 Video output module
+dnl Roku HD1000 Video and Audio output module
 dnl
-AC_ARG_ENABLE(hd1000v,
-  [  --enable-hd1000v        HD1000 Video Output module (default enabled on HD1000)])
-AS_IF([{ VLC_FEATURE_NOT_DISABLED([hd1000v]) && test "${CXX}" != "" && test "${SYS}" != "mingw32" && test "${SYS}" != "mingwce" ;} || VLC_FEATURE_ENABLED([hd1000v])], [
+AS_IF([test "${SYS}" != "mingw32" && test "${SYS}" != "mingwce"], [
+  VLC_FEATURE_DEFAULT_ENABLE([hd1000v hd1000a])
+], [
+  VLC_FEATURE_DEFAULT_DISABLE([hd1000v hd1000a])
+])
+VLC_FEATURE_OPTION([hd1000v], [HD1000 Video Output module], [enabled on HD1000])
+
+AS_IF([VLC_FEATURE_ENABLED([hd1000v]) && test "${CXX}" != ""], [
   AC_LANG_PUSH([C++])
   AC_CHECK_HEADERS([cascade/graphics/CascadeScreen.h cascade/graphics/CascadeBitmap.h],
   [
@@ -3536,14 +3456,16 @@ dnl
 dnl  Windows DirectX module
 dnl
 
+VLC_FEATURE_DEFAULT_DISABLE([directx])
+
 if test "${SYS}" = "mingw32" -o "${SYS}" = "mingwce"
 then
   VLC_ADD_PLUGIN([panoramix])
+  VLC_FEATURE_DEFAULT_ENABLE([directx])
 fi
 
-AC_ARG_ENABLE(directx,
-  [  --enable-directx        Win32 DirectX support (default enabled on Win32)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([directx])], [
+VLC_FEATURE_OPTION([directx], [Win32 DirectX support], [enabled on Win32])
+AS_IF([VLC_FEATURE_ENABLED([directx])], [
   if test "${SYS}" = "mingw32" -o "${SYS}" = "mingwce"
   then
       AC_CHECK_HEADERS(ddraw.h,
@@ -3566,9 +3488,13 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([directx])], [
 dnl
 dnl  win32 GDI plugin
 dnl
-AC_ARG_ENABLE(wingdi,
-  [  --enable-wingdi         Win32 GDI module (default enabled on Win32)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([wingdi])], [
+AS_IF([{ test "${SYS}" = "mingw32" || test "${SYS}" = "mingwce"; }], [
+  VLC_FEATURE_DEFAULT_ENABLE([wingdi])
+], [
+  VLC_FEATURE_DEFAULT_DISABLE([wingdi])
+])
+VLC_FEATURE_OPTION([wingdi], [Win32 GDI module], [enabled on Win32])
+AS_IF([VLC_FEATURE_ENABLED([wingdi])], [
   if test "${SYS}" = "mingw32"; then
     VLC_ADD_PLUGIN([wingdi])
     VLC_ADD_LIBS([wingdi],[-lgdi32 -lole32])
@@ -3584,9 +3510,9 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([wingdi])], [
 dnl
 dnl  Linux framebuffer module
 dnl
-AC_ARG_ENABLE(fb,
-  [  --enable-fb             Linux framebuffer support (default enabled on Linux)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([fb])], [
+VLC_FEATURE_DEFAULT_ENABLE([fb])
+VLC_FEATURE_OPTION([fb], [Linux framebuffer support], [enabled on Linux])
+AS_IF([VLC_FEATURE_ENABLED([fb])], [
       AC_CHECK_HEADERS(linux/fb.h, [
         VLC_ADD_PLUGIN([fb])
       ])
@@ -3595,8 +3521,7 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([fb])], [
 dnl
 dnl  OMAP Framebuffer module
 dnl
-AC_ARG_ENABLE(omapfb,
-  [  --enable-omapfb         OMAP framebuffer support (default disabled)])
+VLC_FEATURE_OPTION([omapfb], [OMAP framebuffer support], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([omapfb])], [
       AC_CHECK_HEADERS(asm/arch-omap/omapfb.h, [
         VLC_ADD_PLUGIN([omapfb])
@@ -3609,8 +3534,7 @@ AS_IF([VLC_FEATURE_ENABLED([omapfb])], [
 dnl
 dnl  SVGAlib module
 dnl
-AC_ARG_ENABLE(svgalib,
-  [  --enable-svgalib        SVGAlib support (default disabled)])
+VLC_FEATURE_OPTION([svgalib], [SVGAlib support], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([svgalib])], [
   VLC_ADD_PLUGIN([svgalib])
   VLC_ADD_LIBS([svgalib],[-lvgagl -lvga])
@@ -3621,8 +3545,7 @@ dnl  DirectFB module
 dnl  try to find using: 1 - given location; 2 - directfb-config; 3 - pkg-config
 dnl  TODO: support for static linking
 dnl
-AC_ARG_ENABLE(directfb,
-  [  --enable-directfb       DirectFB support (default disabled)])
+VLC_FEATURE_OPTION([directfb], [DirectFB support], [disabled])
 AC_ARG_WITH(directfb,
   [  --with-directfb=PATH    path to DirectFB headers and libraries])
 AS_IF([VLC_FEATURE_ENABLED([directfb])], [
@@ -3688,8 +3611,7 @@ AS_IF([VLC_FEATURE_ENABLED([directfb])], [
 dnl
 dnl  GGI module
 dnl
-AC_ARG_ENABLE(ggi,
-  [  --enable-ggi            GGI support (default disabled)])
+VLC_FEATURE_OPTION([ggi], [GGI support], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([ggi])], [
   AC_CHECK_HEADER([ggi/ggi.h],[
     VLC_ADD_PLUGIN([ggi])
@@ -3709,8 +3631,7 @@ AS_IF([VLC_FEATURE_ENABLED([ggi])], [
 dnl
 dnl  AA plugin
 dnl
-AC_ARG_ENABLE(aa,
-  [  --enable-aa             aalib output (default disabled)])
+VLC_FEATURE_OPTION([aa], [aalib output], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([aa])], [
   AC_CHECK_HEADER(aalib.h,have_aa="true",have_aa="false")
   if test "${have_aa}" = "true"
@@ -3734,9 +3655,13 @@ AC_ARG_WITH(,[Audio plugins:])
 dnl
 dnl  OSS /dev/dsp module (enabled by default except on win32)
 dnl
-AC_ARG_ENABLE(oss,
-  [  --enable-oss            Linux OSS /dev/dsp support (enabled on Linux)])
-AS_IF([{ VLC_FEATURE_NOT_DISABLED([oss]) && test "${SYS}" != "mingw32" && test "${SYS}" != "mingwce" ;} || VLC_FEATURE_ENABLED([oss])], [
+AS_IF([{ test "${SYS}" != "mingw32" && test "${SYS}" != "mingwce"; }], [
+  VLC_FEATURE_DEFAULT_ENABLE([oss])
+], [
+  VLC_FEATURE_DEFAULT_DISABLE([oss])
+])
+VLC_FEATURE_OPTION([oss], [Linux OSS /dev/dsp support], [enabled on Linux])
+AS_IF([VLC_FEATURE_ENABLED([oss])], [
   AC_CHECK_HEADERS([soundcard.h sys/soundcard.h], [
     VLC_ADD_PLUGIN([oss access_oss])
     AC_CHECK_LIB(ossaudio,main,[VLC_ADD_LIBS([oss access_oss],[-lossaudio])])
@@ -3761,9 +3686,13 @@ PKG_ENABLE_MODULES_VLC([ALSA], [alsa access_alsa], [alsa >= 1.0.0], [Alsa sound
 dnl
 dnl  win32 waveOut plugin
 dnl
-AC_ARG_ENABLE(waveout,
-  [  --enable-waveout        Win32 waveOut module (default enabled on Win32)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([waveout])], [
+AS_IF([{ test "${SYS}" = "mingw32" || test "${SYS}" = "mingwce"; }], [
+  VLC_FEATURE_DEFAULT_ENABLE([waveout])
+], [
+  VLC_FEATURE_DEFAULT_DISABLE([waveout])
+])
+VLC_FEATURE_OPTION([waveout], [Win32 waveOut module], [enabled on Win32])
+AS_IF([VLC_FEATURE_ENABLED([waveout])], [
   if test "${SYS}" = "mingw32"; then
     VLC_ADD_PLUGIN([waveout])
     VLC_ADD_LIBS([waveout],[-lwinmm])
@@ -3776,9 +3705,13 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([waveout])], [
 dnl
 dnl  CoreAudio plugin
 dnl
-AC_ARG_ENABLE(macosx-audio,
-  [  --enable-macosx-audio   Mac OS X audio module (default enabled on MacOS X)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([macosx-audio]) && { test "${SYS}" = "darwin" || VLC_FEATURE_ENABLED([macosx-audio]) ;}], [
+AS_IF([test "${SYS}" = "darwin"], [
+  VLC_FEATURE_DEFAULT_ENABLE([macosx-audio])
+], [
+  VLC_FEATURE_DEFAULT_DISABLE([macosx-audio])
+])
+VLC_FEATURE_OPTION([macosx-audio], [Mac OS X audio module], [enabled on Mac OS X])
+AS_IF([VLC_FEATURE_ENABLED([macosx-audio])], [
   AC_CHECK_HEADERS(CoreAudio/CoreAudio.h,
     [ VLC_ADD_PLUGIN([auhal])
       VLC_ADD_LDFLAGS([auhal],[-Wl,-framework,CoreAudio,-framework,AudioUnit,-framework,AudioToolbox,-framework,Carbon])
@@ -3788,9 +3721,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([macosx-audio]) && { test "${SYS}" = "darwin" ||
 dnl
 dnl  Roku HD1000 audio
 dnl
-AC_ARG_ENABLE(hd1000a,
-  [  --enable-hd1000a        HD1000 audio module (default enabled on HD1000)])
-AS_IF([{ VLC_FEATURE_NOT_DISABLED([hd1000a]) && test "${CXX}" != "" && test "${SYS}" != "mingw32" && test "${SYS}" != "mingwce" ;} || VLC_FEATURE_ENABLED([hd1000a])], [
+VLC_FEATURE_OPTION([hd1000a], [HD1000 Audio Output module], [enabled on HD1000])
+AS_IF([VLC_FEATURE_ENABLED([hd1000a]) && test "${CXX}" != ""], [
   AC_LANG_PUSH([C++])
   AC_CHECK_HEADERS(deschutes/libraries/hdmachinex225/PCMAudioPlayer.h, [
     VLC_ADD_PLUGIN([hd1000a])
@@ -3807,8 +3739,7 @@ PKG_ENABLE_MODULES_VLC([JACK], [jack access_jack], [jack], [JACK audio I/O modul
 dnl
 dnl  CyberLink for C++ UPnP stack
 dnl
-AC_ARG_ENABLE(cyberlink,
-  [  --enable-cyberlink      CyberLink for C++ UPnP stack (default disabled)])
+VLC_FEATURE_OPTION([cyberlin], [CyberLink for C++ UPnP stack], [disabled])
   AS_IF([VLC_FEATURE_ENABLED([cyberlink])], [
   AC_ARG_WITH(cyberlink-tree,
     [  --with-cyberlink-tree=PATH CyberLink for C++ tree for static linking])
@@ -3891,14 +3822,12 @@ AC_ARG_WITH(,[Interface plugins:])
 dnl
 dnl Skins2 module
 dnl
-AC_ARG_ENABLE(skins2,
-  [AS_HELP_STRING([--enable-skins2],[Skins2 interface module (default
-   enabled except on MacOSX, BeOS and WinCE)])])
 AS_CASE(
   ["${SYS}"],
-  [darwin|beos|mingwce], [],
+  [darwin|beos|mingwce], [VLC_FEATURE_DEFAULT_DISABLE([skins2])],
   [VLC_FEATURE_DEFAULT_ENABLE([skins2])]
 )
+VLC_FEATURE_OPTION([skins2], [Skins2 interface module], [enabled except on MacOSX, BeOS and WinCE])
 AS_IF([VLC_FEATURE_ENABLED([skins2])], [
   dnl test for the required libraries
   skins2_missing_lib="no"
@@ -3939,8 +3868,7 @@ AM_CONDITIONAL(BUILD_SKINS, [test "${skins2_missing_lib}" = "no"])
 dnl
 dnl Hildon UI
 dnl
-AC_ARG_ENABLE(hildon,
-  [  --enable-hildon         Hildon touchscreen UI (default disabled)])
+VLC_FEATURE_OPTION([hildon], [Hildon touchscreen UI], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([hildon])], [
   PKG_CHECK_MODULES(HILDON, [hildon-1 hildon-fm-2], [
     VLC_ADD_CFLAGS([hildon],[${HILDON_CFLAGS}])
@@ -3957,10 +3885,13 @@ AM_CONDITIONAL(BUILD_HILDON, [VLC_FEATURE_ENABLED([hildon])])
 dnl
 dnl QT 4
 dnl
-AS_IF([test "x${SYS}" = "xdarwin"], [VLC_FEATURE_DEFAULT_DISABLE([qt4])])
-AC_ARG_ENABLE(qt4,
-  [  --enable-qt4            Qt 4 support (default enabled) ])
-AS_IF([VLC_FEATURE_NOT_DISABLED([qt4])], [
+AS_IF([test "x${SYS}" = "xdarwin"], [
+  VLC_FEATURE_DEFAULT_DISABLE([qt4]),
+], [
+  VLC_FEATURE_DEFAULT_ENABLE([qt4])
+])
+VLC_FEATURE_OPTION([qt4], [Qt 4 support], [enabled except on darwin])
+AS_IF([VLC_FEATURE_ENABLED([qt4])], [
   PKG_CHECK_MODULES(QT4, [QtCore QtGui >= 4.4.0], [
     VLC_ADD_PLUGIN([qt4])
     ALIASES="${ALIASES} qvlc"
@@ -3990,15 +3921,16 @@ AM_CONDITIONAL(ENABLE_QT4, [test "x$have_qt4" = "xyes"])
 dnl
 dnl Simple test for skins2 dependency
 dnl
-AS_IF([VLC_FEATURE_NOT_DISABLED([skins2]) && test "x$have_qt4" != "xyes"], [
+AS_IF([VLC_FEATURE_ENABLED([skins2]) && test "x$have_qt4" != "xyes"], [
   AC_MSG_ERROR([The skins2 module depends on a the Qt4 development package. Without it you won't be able to open any dialog box from the interface, which makes the skins2 interface rather useless. Install the Qt4 development package or alternatively you can also configure with: --disable-qt4 --disable-skins2.])
 ])
 
 dnl
 dnl  MacOS X video output/gui modules
 dnl
-AC_ARG_ENABLE(macosx,
-  [  --enable-macosx         Mac OS X gui support (default enabled on Mac OS X)])
+dnl default disable, forced by macosx-defaults
+VLC_FEATURE_DEFAULT_DISABLE([macosx])
+VLC_FEATURE_OPTION([macosx], [Mac OS X gui support], [enabled on Mac OS X])
 AS_IF([VLC_FEATURE_ENABLED([macosx])], [
   VLC_ADD_LDFLAGS([macosx minimal_macosx],[-Wl,-framework,Cocoa])
   VLC_ADD_LDFLAGS([macosx minimal_macosx],[-Wl,-framework,OpenGL])
@@ -4020,24 +3952,27 @@ dnl
 dnl  MacOS X related modules
 dnl
 
-AC_ARG_ENABLE(macosx-vout,
-  [  --enable-macosx-vout    Mac OS X video output module (default enabled on Mac OS X)])
-AS_IF([{ VLC_FEATURE_NOT_DISABLED([macosx-vout]) && test "${SYS}" = "darwin" ;} || VLC_FEATURE_ENABLED([macosx-vout])], [
+AS_IF([test "${SYS}" = "darwin"], [
+  VLC_FEATURE_DEFAULT_ENABLE([macosx-vout macosx-dialog-provider macosx-qtcapture macosx-eyetv macosx-vlc-app])
+], [
+  VLC_FEATURE_DEFAULT_DISABLE([macosx-vout macosx-dialog-provider macosx-qtcapture macosx-eyetv macosx-vlc-app])
+])
+
+VLC_FEATURE_OPTION([macosx-vout], [Mac OS X video output module], [enabled on Mac OS X])
+AS_IF([VLC_FEATURE_ENABLED([macosx-vout])], [
   VLC_ADD_LDFLAGS([vout_macosx],[-Wl,-framework,Cocoa])
   VLC_ADD_LDFLAGS([vout_macosx],[-Wl,-framework,OpenGL])
   VLC_ADD_PLUGIN([vout_macosx])
 ])
 
-AC_ARG_ENABLE(macosx-dialog-provider,
-  [  --enable-macosx-dialog-provider Mac OS X dialog module (default enabled on Mac OS X)])
-AS_IF([{ VLC_FEATURE_NOT_DISABLED([macosx-dialog-provider]) && test "${SYS}" = "darwin" ;} || VLC_FEATURE_ENABLED([macosx-dialog-provider])], [
+VLC_FEATURE_OPTION([macosx-dialog-provider], [Mac OS X dialog module], [enabled on Mac OS X])
+AS_IF([VLC_FEATURE_ENABLED([macosx-dialog-provider])], [
   VLC_ADD_LDFLAGS([macosx_dialog_provider],[-Wl,-framework,Cocoa])
   VLC_ADD_PLUGIN([macosx_dialog_provider])
 ])
 
-AC_ARG_ENABLE(macosx-qtcapture,
-  [  --enable-macosx-qtcapture Mac OS X qtcapture (iSight) module (default enabled on Mac OS X)])
-AS_IF([{ VLC_FEATURE_NOT_DISABLED([macosx-qtcapture]) && test "${SYS}" = "darwin" ;} || VLC_FEATURE_ENABLED([macosx-qtcapture])], [
+VLC_FEATURE_OPTION([macosx-qtcapture], [Mac OS X qtcapture (iSight) module], [enabled on Mac OS X])
+AS_IF([VLC_FEATURE_ENABLED([macosx-qtcapture])], [
   VLC_ADD_LDFLAGS([qtcapture], [-Wl,-framework,Cocoa])
   VLC_ADD_LDFLAGS([qtcapture], [-Wl,-framework,QTKit])
   VLC_ADD_LDFLAGS([qtcapture], [-Wl,-framework,CoreAudio])
@@ -4046,24 +3981,20 @@ AS_IF([{ VLC_FEATURE_NOT_DISABLED([macosx-qtcapture]) && test "${SYS}" = "darwin
   VLC_ADD_PLUGIN([qtcapture])
 ])
 
-AC_ARG_ENABLE(macosx-eyetv,
-  [  --enable-macosx-eyetv   Mac OS X EyeTV (TNT Tuner) module (default enabled on Mac OS X)])
-AS_IF([{ VLC_FEATURE_NOT_DISABLED([macosx-eyetv]) && test "${SYS}" = "darwin" ;} || VLC_FEATURE_ENABLED([macosx-eyetv])], [
+VLC_FEATURE_OPTION([macosx-eyetv], [Mac OS X EyeTV (TNT Tuner) module], [enabled on Mac OS X])
+AS_IF([VLC_FEATURE_ENABLED([macosx-eyetv])], [
   VLC_ADD_LDFLAGS([access_eyetv], [-Wl,-framework,Foundation])
   VLC_ADD_PLUGIN([access_eyetv])
 ])
 
-AC_ARG_ENABLE(macosx-vlc-app,
-  [  --enable-macosx-vlc-app build the VLC media player (default enabled on Mac OS X)])
-AM_CONDITIONAL(BUILD_MACOSX_VLC_APP,
-  [{ VLC_FEATURE_NOT_DISABLED([macosx-vlc-app]) && test "${SYS}" = "darwin" ;} || VLC_FEATURE_ENABLED([macosx-vlc-app])])
+VLC_FEATURE_OPTION([macosx-vlc-app], [build the VLC media player], [enabled on Mac OS X])
+AM_CONDITIONAL(BUILD_MACOSX_VLC_APP, [VLC_FEATURE_ENABLED([macosx-vlc-app])])
 
 
 dnl
 dnl  ncurses module
 dnl
-AC_ARG_ENABLE(ncurses,
-  [  --disable-ncurses       ncurses interface support (default disabled)])
+VLC_FEATURE_OPTION([ncurses], [ncurses interface support], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([ncurses])], [
     AC_CHECK_HEADER(ncurses.h,
       [AC_CHECK_LIB(ncursesw, mvprintw,
@@ -4097,8 +4028,7 @@ AS_IF([VLC_FEATURE_ENABLED([ncurses])], [
 dnl
 dnl  XOSD plugin
 dnl
-AC_ARG_ENABLE(xosd,
-  [  --enable-xosd           xosd interface support (default disabled)])
+VLC_FEATURE_OPTION([xosd], [xosd interface support], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([xosd])], [
   AC_CHECK_HEADERS(xosd.h,
     AC_CHECK_LIB(xosd, xosd_set_horizontal_offset, [
@@ -4111,8 +4041,7 @@ AS_IF([VLC_FEATURE_ENABLED([xosd])], [
 dnl
 dnl Framebuffer (overlay) plugin
 dnl
-AC_ARG_ENABLE(fbosd,
-  [  --enable-fbosd          fbosd interface support (default disabled)])
+VLC_FEATURE_OPTION([fbosd], [fbosd interface support], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([fbosd])], [
   AC_CHECK_HEADERS(linux/fb.h, [
     VLC_ADD_PLUGIN([fbosd])
@@ -4129,9 +4058,8 @@ AS_IF([test "$need_xid_provider" = "yes"], [
 dnl
 dnl Visualisation plugin
 dnl
-AC_ARG_ENABLE(visual,
-  [  --enable-visual         visualisation plugin (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([visual])], [
+VLC_FEATURE_OPTION([visual], [visualisation plugin])
+AS_IF([VLC_FEATURE_ENABLED([visual])], [
     VLC_ADD_PLUGIN([visual])
 ])
 
@@ -4148,10 +4076,8 @@ PKG_ENABLE_MODULES_VLC([PROJECTM], [], [libprojectM], [projectM visualization pl
 dnl
 dnl  AtmoLight (homemade Philips Ambilight clone)
 dnl
-AC_ARG_ENABLE(atmo,
-AS_HELP_STRING([--disable-atmo],[AtmoLight (homemade Philips Ambilight clone)
-                (default enabled)]))
-AS_IF([VLC_FEATURE_NOT_DISABLED([atmo])], [
+VLC_FEATURE_OPTION([atmo], [AtmoLight (homemade Philips Ambilight clone)])
+AS_IF([VLC_FEATURE_ENABLED([atmo])], [
   AS_IF([test "${SYS}" = "mingw32" -o "${SYS}" = "linux"], [
     AC_LANG_PUSH(C++)
     VLC_ADD_PLUGIN([atmo])
@@ -4174,8 +4100,7 @@ PKG_ENABLE_MODULES_VLC([MTP], [], [libmtp >= 0.3.0],[MTP devices support],[auto]
 dnl
 dnl  Lirc plugin
 dnl
-AC_ARG_ENABLE(lirc,
-  [  --enable-lirc           lirc support (default disabled)])
+VLC_FEATURE_OPTION([lirc], [lirc support], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([lirc])], [
   AC_CHECK_HEADER(lirc/lirc_client.h, AC_CHECK_LIB(lirc_client, lirc_init, have_lirc="true", have_lirc="false"),have_lirc="false")
   if test "${have_lirc}" = "true"
@@ -4191,9 +4116,8 @@ AC_ARG_WITH(,[Misc options:])
 dnl
 dnl libgcrypt
 dnl
-AC_ARG_ENABLE(libgcrypt,
-  [  --disable-libgcrypt     gcrypt support (default enabled)])
-AS_IF([VLC_FEATURE_NOT_DISABLED([libgcrypt])], [
+VLC_FEATURE_OPTION([libgcrypt], [gcrypt support])
+AS_IF([VLC_FEATURE_ENABLED([libgcrypt])], [
   AC_CHECK_DECL([GCRYCTL_SET_THREAD_CBS], [
     libgcrypt-config --version >/dev/null || \
         AC_MSG_ERROR([gcrypt.h present but libgcrypt-config could not be found])
